// T&ESOFT NEW 3D GOLF SIMULATION ver.2.0p
// kt@CWJvO

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char *argv[])
{
	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s (.PRC File)\n",argv[0]);
		return 1;
	}

	int i,j;
	char fname1[FILENAME_MAX];
	char fname2[FILENAME_MAX];

	int head=0;				// wb_
	int orgsize=0;			// WJOTCY
	int decsize=0;			// WJTCY
	unsigned char key=0;	// ÍfR[hL[
	unsigned char tmp;
	int dt;
	FILE *ifp,*ofp;

	// WJt@CI[v
	ifp = fopen(argv[1],"rb");
	if (ifp==NULL)
	{ 
		fprintf(stderr, "t@CJ܂.\n");
		return 1;
	}

	// o̓t@CAI[v
	strcpy(fname1,argv[1]);		// ̓t@C
	strcat(fname1,".$$$");		// e|t@C
	strcpy(fname2,argv[1]);
	strcat(fname2,".BAK");		// obNAbvt@C
	ofp = fopen(fname1,"wb");

	// wb_ǂ
	head  = fgetc(ifp);
	head += fgetc(ifp)*0x100;
	orgsize += 2;

	if (head==0)
	{
		// k̏ꍇ̓wb_Ă̂܂܃Rs[
		while (!feof(ifp))
		{
			dt = fgetc(ifp);
			fputc(dt,ofp);
			orgsize++, decsize++;
		}
	}
	else
	{
		int lzsize = (0x100>>head)+2;			// XChTCY
		unsigned char lzmask = ((0x100>>head)-1)^0xff;	// LZWJp}XN
		int buffsize = 0x100<<head;				// Oobt@̃TCY
		int buffmask = buffsize -1;				// Oobt@p}XN
		int bp = buffsize - lzsize;				// Oobt@̏ʒu
		unsigned char C,D,D1,D2;
		int adr, len;							// Oobt@QƈʒuƃTCY
//		printf("header : %04x\nlzsize : %04x\nlzmask : %04x\nbufsiz : %04x\nbufmsk : %04x\nbufptr : %04x\n",head,lzsize,lzmask,buffsize,buffmask,bp);

		// Oobt@̃m
		unsigned char *buff = (unsigned char*) calloc(buffsize, sizeof(unsigned char));
		if (!buff)
		{
			fprintf(stderr,"̊蓖Ăł܂.\n");
			return 1;
		}

		// WJ
		while (1)
		{
			// 1byte[hktOƂ
			tmp = fgetc(ifp);
			if (feof(ifp)) break;
			C = tmp - key;
			key = tmp;
			orgsize++;

			for (i=0; i<8; i++)	// 8bit[v
			{
				if (C&1==1)
				{
					// TCrbg1̎͂̂܂܃Rs[
					tmp = fgetc(ifp);
					if (feof(ifp)) break;
					D = tmp - key;
					key = tmp;
					orgsize++;
					buff[bp] = D;		// Oobt@ɋL
					fputc(D,ofp);		// 1byteo
					decsize++;
					++bp &= buffmask;	// |C^i߂
				}
				else
				{
					// TCrbg0͓̎WJ
					tmp = fgetc(ifp);	// 2byteǂݍ
					if (feof(ifp)) break;
					D1 = tmp - key;
					key = tmp;
					orgsize++;

					tmp = fgetc(ifp);
					if (feof(ifp)) break;
					D2 = tmp - key;
					key = tmp;
					orgsize++;

					adr = D1 + ((D2&lzmask)<<head);	// XCḧʒu
					len = (D2&(lzmask^0xff))+3;		// 

					// XChQƂďo
					for (j=0; j<len; j++)
					{
						D = buff[adr];			// QƂēǂݏo
						buff[bp] = D;			// L
						fputc(D,ofp);			// 1byteo
						decsize++;
						++bp  &= buffmask;
						++adr &= buffmask;		// |C^i߂
					}
					if (feof(ifp)) break;
				}
				C=C>>1;
			}
		}
		free(buff);
	}
	fclose(ifp);
	fclose(ofp);
	// l[
	rename(argv[1],fname2);
	rename(fname1,argv[1]);
	printf("Extract : %d -> %d\n",orgsize,decsize-4);
	return 0;
}

